/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.customeric;

import org.apache.wicket.Page;
import org.apache.wicket.Request;
import org.apache.wicket.RequestCycle;
import org.apache.wicket.Response;
import org.apache.wicket.protocol.http.WebApplication;
import org.apache.wicket.protocol.http.WebRequest;
import org.apache.wicket.protocol.http.WebResponse;
import org.apache.wicket.request.IRequestCycleProcessor;
import org.jboss.weld.wicket.BeanManagerLookup;
import org.jboss.weld.wicket.WeldComponentInstantiationListener;
import org.jboss.weld.wicket.WeldRequestCycle;
import org.jboss.weld.wicket.WeldWebRequestCycleProcessor;
import org.jboss.weld.wicket.util.NonContextual;

/**
 *
 * @author I047997
 */
public class CustomericApplication extends WebApplication{
   @Override
    public Class<? extends Page> getHomePage() {
        return HomePage.class;
        
    }



     private NonContextual<WeldComponentInstantiationListener> weldComponentInstantiationListener;
   private NonContextual<WeldWebRequestCycleProcessor> weldWebRequestCycleProcessor;

   /**
    */

   /**
    * Add our component instantiation listener
    *
    * @see WeldComponentInstantiationListener
    */
   @Override
   protected void internalInit()
   {
      super.internalInit();
      this.weldComponentInstantiationListener = new NonContextual<WeldComponentInstantiationListener>(BeanManagerLookup.getBeanManager(), WeldComponentInstantiationListener.class);
      this.weldWebRequestCycleProcessor = new NonContextual<WeldWebRequestCycleProcessor>(BeanManagerLookup.getBeanManager(), WeldWebRequestCycleProcessor.class);
      addComponentInstantiationListener(weldComponentInstantiationListener.newInstance().produce().inject().get());
   }


   /**
    * Override to return our Weld-specific request cycle processor
    *
    * @see WeldWebRequestCycleProcessor
    */
   @Override
   protected IRequestCycleProcessor newRequestCycleProcessor()
   {
      return weldWebRequestCycleProcessor.newInstance().produce().inject().get();
   }

   /**
    * Override to return our Weld-specific request cycle
    *
    * @see WeldRequestCycle
    */
   @Override
   public RequestCycle newRequestCycle(final Request request, final Response response)
   {
      return new WeldRequestCycle(this, (WebRequest) request, (WebResponse) response);
   }


}
